## adios2 2.11.0+dfsg1

=== CMakeLists.txt ===
#------------------------------------------------------------------------------#
# Distributed under the OSI-approved Apache License, Version 2.0.  See
# accompanying file Copyright.txt for details.
#------------------------------------------------------------------------------#

cmake_minimum_required(VERSION 3.14)

# Fail immediately if not using an out-of-source build
if(CMAKE_CURRENT_SOURCE_DIR STREQUAL CMAKE_CURRENT_BINARY_DIR)
  message(FATAL_ERROR
    "In-source builds are not supported.  Please create a build directory "
    "separate from the source directory")
endif()

include(${CMAKE_CURRENT_LIST_DIR}/cmake/ADIOSFunctions.cmake)

setup_version(2.11.0)

project(ADIOS2 VERSION ${ADIOS2_VERSION})

#------------------------------------------------------------------------------#
# Some boilerplate to setup nice output directories
#------------------------------------------------------------------------------#
include(GNUInstallDirs)

if (ADIOS2_USE_PIP)
  # Only UNIX is supported currently
  if (UNIX)
    # Linux bundles what libraries we have when they're put beside the modules.
    set(CMAKE_INSTALL_LIBDIR "adios2")
    set(CMAKE_INSTALL_INCLUDEDIR "adios2/include")
    # ELF loader settings.
    set(CMAKE_BUILD_WITH_INSTALL_RPATH ON)
    list(APPEND CMAKE_INSTALL_RPATH "$ORIGIN")
  endif ()
endif ()

set(CMAKE_INSTALL_CMAKEDIR ${CMAKE_INSTALL_LIBDIR}/cmake/adios2
  CACHE STRING "Installation CMake subdirectory")
mark_as_advanced(CMAKE_INSTALL_CMAKEDIR)

list(INSERT CMAKE_MODULE_PATH 0 "${PROJECT_SOURCE_DIR}/cmake")
if(NOT CMAKE_ARCHIVE_OUTPUT_DIRECTORY)
  set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY
    ${PROJECT_BINARY_DIR}/${CMAKE_INSTALL_LIBDIR})
endif()
if(NOT CMAKE_LIBRARY_OUTPUT_DIRECTORY)
  set(CMAKE_LIBRARY_OUTPUT_DIRECTORY
    ${PROJECT_BINARY_DIR}/${CMAKE_INSTALL_LIBDIR})
endif()
if(NOT CMAKE_RUNTIME_OUTPUT_DIRECTORY)
  set(CMAKE_RUNTIME_OUTPUT_DIRECTORY
    ${PROJECT_BINARY_DIR}/${CMAKE_INSTALL_BINDIR})
endif()

# Let windows builds auto-export dll symbols
set(CMAKE_WINDOWS_EXPORT_ALL_SYMBOLS TRUE)

set(CMAKE_EXPORT_COMPILE_COMMANDS ON)

#------------------------------------------------------------------------------#
# Silence MSVC warnings
#------------------------------------------------------------------------------#

if(MSVC)
  add_definitions(
    -D_CRT_SECURE_NO_DEPRECATE
    -D_CRT_SECURE_NO_WARNINGS
    -D_SCL_SECURE_NO_DEPRECATE
    -D_WINSOCK_DEPRECATED_NO_WARNINGS
    -D_SILENCE_TR1_NAMESPACE_DEPRECATION_WARNING
  )
endif()

function(append_str_list_once var x)
  foreach(item IN ITEMS ${${var}})
    if(item STREQUAL x)
      return()
    endif()
  endforeach()
  set(out ${${var}} ${x})
  string(REPLACE ";" " " out "${out}")
  set(${var} "${out}" PARENT_SCOPE)
endfunction()

if(NOT MSVC)
  set(CMAKE_C_COMPILER_FLAGS_DEBUG "${CMAKE_C_COMPILER_FLAGS_DEBUG}"
    CACHE STRING "" FORCE
  )
  set(CMAKE_CXX_COMPILER_FLAGS_DEBUG "${CMAKE_CXX_COMPILER_FLAGS_DEBUG}"
    CACHE STRING "" FORCE
  )
endif()

#------------------------------------------------------------------------------#
# Deal with any pre-installation cleanup tasks
#------------------------------------------------------------------------------#
add_subdirectory(cmake/install/pre)

#------------------------------------------------------------------------------#
# Top level options
#------------------------------------------------------------------------------#

# Default to a debug build if not specified
if(NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES)
  set(CMAKE_BUILD_TYPE "Release" CACHE STRING "Choose the type of build." FORCE)
endif()

# This C++ standard is required to build ADIOS2
set(ADIOS2_REQUIRED_CXX_STANDARD 14)
if(NOT DEFINED CMAKE_CXX_STANDARD)
  set(CMAKE_CXX_STANDARD ${ADIOS2_REQUIRED_CXX_STANDARD})
  set(CMAKE_CXX_STANDARD_REQUIRED ON)
elseif(CMAKE_CXX_STANDARD LESS ADIOS2_REQUIRED_CXX_STANDARD)
  message(FATAL_ERROR "Requested CMAKE_CXX_STANDARD=${CMAKE_CXX_STANDARD} which is less than the required ${ADIOS2_REQUIRED_CXX_STANDARD}.")
endif()

if(NOT MSVC)
  if(NOT CMAKE_C_STANDARD)
    set(CMAKE_C_STANDARD 99)
  endif()
  set(CMAKE_C_STANDARD_REQUIRED ON)
endif()

# Option for packagers to add a suffix after "adios" in library names (to
# install multiple builds in parallel)
set(ADIOS2_LIBRARY_SUFFIX "" CACHE STRING
  "Suffix to put after \"adios\" in library names")
set(ADIOS2_EXECUTABLE_SUFFIX "${ADIOS2_LIBRARY_SUFFIX}" CACHE STRING
  "Suffix to append to executable names")
mark_as_advanced(ADIOS2_LIBRARY_SUFFIX ADIOS2_EXECUTABLE_SUFFIX)

# Use meta-compile features if available, otherwise use specific language
# features
if(CMAKE_CXX_COMPILER_ID MATCHES "^(GNU|Intel|Clang|AppleClang|MSVC)$")
  set(ADIOS2_CXX11_FEATURES cxx_auto_type cxx_nullptr)
else()
  set(ADIOS2_CXX11_FEATURES cxx_std_11)
endif()
if(CMAKE_C_COMPILER_ID MATCHES "^(GNU|Intel|Clang|AppleClang|MSVC)$")
  set(ADIOS2_C99_FEATURES c_restrict)
else()
  set(ADIOS2_C99_FEATURES c_std_99)
endif()

include(CMakeDependentOption)

# Setup shared library defaults.  If explicitly specified somehow, then default
# to that.  Otherwise base the default on whether or not shared libs are even
# supported.
get_property(SHARED_LIBS_SUPPORTED GLOBAL PROPERTY TARGET_SUPPORTS_SHARED_LIBS)
cmake_dependent_option(BUILD_SHARED_LIBS
  "Build shared libraries (so/dylib/dll)." ${SHARED_LIBS_SUPPORTED}
  "SHARED_LIBS_SUPPORTED" OFF
)
mark_as_advanced(BUILD_SHARED_LIBS)
if((NOT BUILD_SHARED_LIBS) AND (NOT DEFINED CMAKE_POSITION_INDEPENDENT_CODE))
  set(CMAKE_POSITION_INDEPENDENT_CODE ON)
endif()

# Ctest creates BUILD_TESTING option and sets it to true by default
# Here we disable BUILD_TESTING option by default
option(BUILD_TESTING "Build testing" OFF)
include(CTest)
mark_as_advanced(CLEAR BUILD_TESTING)

adios_option(BigWhoop   "Enable support for BigWhoop transforms" AUTO)
adios_option(Blosc2     "Enable support for c-blosc-2 transforms" AUTO)
adios_option(BZip2      "Enable support for BZip2 transforms" AUTO)
adios_option(Caliper    "Enable support for Caliper" AUTO)
adios_option(ZFP        "Enable support for ZFP transforms" AUTO)
adios_option(SZ         "Enable support for SZ transforms" AUTO)
adios_option(LIBPRESSIO "Enable support for LIBPRESSIO transforms" AUTO)
adios_option(MGARD      "Enable support for MGARD transforms" AUTO)
adios_option(PNG        "Enable support for PNG transforms" AUTO)
adios_option(CUDA       "Enable support for Cuda" OFF)
adios_option(Kokkos     "Enable support for Kokkos" OFF)
adios_option(MPI        "Enable support for MPI" AUTO)
adios_option(DAOS       "Enable support for DAOS" AUTO)
adios_option(DataMan    "Enable support for DataMan" AUTO)
adios_option(DataSpaces "Enable support for DATASPACES" AUTO)
adios_option(MHS        "Enable support for MHS" AUTO)
adios_option(SST        "Enable support for SST" AUTO)
adios_option(ZeroMQ     "Enable support for ZeroMQ" AUTO)
adios_option(HDF5       "Enable support for the HDF5 engine" AUTO)
adios_option(HDF5_VOL   "Enable support for HDF5 ADIOS2 VOL" AUTO)
adios_option(IME        "Enable support for DDN IME transport" AUTO)
adios_option(Python     "Enable support for Python bindings" AUTO)
adios_option(Fortran    "Enable support for Fortran bindings" AUTO)
adios_option(SysVShMem  "Enable support for SysV Shared Memory IPC on *NIX" AUTO)
adios_option(UCX        "Enable support for UCX DataPlane in SST" AUTO)
adios_option(Profiling  "Enable support for profiling" AUTO)
adios_option(Endian_Reverse "Enable support for Little/Big Endian Interoperability" AUTO)
adios_option(Sodium     "Enable support for Sodium for encryption" AUTO)
adios_option(Catalyst   "Enable support for in situ visualization plugin using ParaView Catalyst" AUTO)
adios_option(Campaign   "Enable support for Campaigns (requires SQLite3 and ZLIB)" AUTO)
adios_option(OpenSSL    "Enable support for OpenSSL" AUTO)
adios_option(AWSSDK     "Enable support for S3 compatible storage using AWS SDK's S3 module" OFF)
adios_option(Derived_Variable    "Enable support for derived variables" OFF)
adios_option(PIP        "Enable support for pip packaging" OFF)
adios_option(XRootD     "Enable support for XRootD" AUTO)
adios_option(KVCACHE    "Enable support for KVCache" OFF)

option(ADIOS2_LIBADIOS_MODE "Install only C/C++ library components" OFF)
mark_as_advanced(ADIOS2_LIBADIOS_MODE)
option(ADIOS2_Blosc2_PREFER_SHARED "Prefer shared Blosc2 libraries" ON)
mark_as_advanced(ADIOS2_Blosc2_PREFER_SHARED)
mark_as_advanced(ADIOS2_USE_PIP)
include(${PROJECT_SOURCE_DIR}/cmake/DetectOptions.cmake)

if(ADIOS2_HAVE_CUDA OR ADIOS2_HAVE_Kokkos_CUDA)
  set(CMAKE_CUDA_STANDARD ${CMAKE_CXX_STANDARD})
  set(CMAKE_CUDA_STANDARD_REQUIRED TRUE)
  if(NOT DEFINED CMAKE_CUDA_ARCHITECTURES)
    if(DEFINED Kokkos_CUDA_ARCHITECTURES)
      set(CMAKE_CUDA_ARCHITECTURES ${Kokkos_CUDA_ARCHITECTURES})
    else()
      # Minimum common non-deprecated architecture
      set(CMAKE_CUDA_ARCHITECTURES 52)
    endif()
  endif()
endif()

if(NOT DEFINED CMAKE_HIP_ARCHITECTURES AND DEFINED Kokkos_HIP_ARCHITECTURES)
    set(CMAKE_HIP_ARCHITECTURES ${Kokkos_HIP_ARCHITECTURES})
endif()

if(ADIOS2_HAVE_MPI)
  if(MPIEXEC_MAX_NUMPROCS LESS 4 AND "$ENV{OMPI_MCA_rmaps_base_oversubscribe}")
    message(STATUS "OpenMPI oversubscribe detected: raising MPIEXEC_MAX_NUMPROCS to 4 for testing")
    set(MPIEXEC_MAX_NUMPROCS 4 CACHE STRING "" FORCE)
  endif()

  # Workaround for MPI forcing the link of C++ bindings
  add_definitions(-DOMPI_SKIP_MPICXX -DMPICH_SKIP_MPICXX)
endif()

#------------------------------------------------------------------------------#
# POSIX O_DIRECT is only working for Unix in adios for now
#------------------------------------------------------------------------------#
if(CYGWIN)
  #-tb O_DIRECT messes up cygwin
  set(ADIOS2_HAVE_O_DIRECT 0)
elseif(MSVC)
  # Windows has other things but we are not using them
  set(ADIOS2_HAVE_O_DIRECT 0)
elseif(APPLE)
  # Mac has other things but we are not using them
  set(ADIOS2_HAVE_O_DIRECT 0)
else()

  message(STATUS "Checking for O_DIRECT")
  include(CheckCXXSourceCompiles)
  check_cxx_source_compiles("
#include <unistd.h>
#include <fcntl.h>
int main(int argc, char * argv[]) { argc = O_DIRECT; }
" O_DIRECT_WORKS)

  if (O_DIRECT_WORKS)
    set(ADIOS2_HAVE_O_DIRECT 1)
  else()
    set(ADIOS2_HAVE_O_DIRECT 0)
  endif()

endif()

#if(NOT HAVE_O_DIRECT)
#  message(WARNING " -----  The open() flag O_DIRECT is not available! ---- ")
#else()
#  message(STATUS " -----  The open() flag O_DIRECT is available! ---- ")
#endif()


set(ADIOS2_CONFIG_OPTS
    DataMan DataSpaces HDF5 HDF5_VOL MHS SST Fortran MPI Python PIP BigWhoop Blosc2 BZip2
    LIBPRESSIO MGARD MGARD_MDR PNG SZ ZFP DAOS IME O_DIRECT Sodium Catalyst SysVShMem UCX
    ZeroMQ Profiling Endian_Reverse Derived_Variable AWSSDK OpenSSL XRootD GPU_Support CUDA Kokkos
    Kokkos_CUDA Kokkos_HIP Kokkos_SYCL Campaign KVCACHE
)

GenerateADIOSHeaderConfig(${ADIOS2_CONFIG_OPTS})
configure_file(
  ${PROJECT_SOURCE_DIR}/CTestCustom.cmake.in
  ${PROJECT_BINARY_DIR}/CTestCustom.cmake
  @ONLY
)

install(FILES ${PROJECT_BINARY_DIR}/source/adios2/common/ADIOSConfig.h
  DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/adios2/common
  COMPONENT adios2_core-development
)

#------------------------------------------------------------------------------#
# Some specialized shared library and RPATH handling
#------------------------------------------------------------------------------#
option(ADIOS2_RUN_INSTALL_TEST "Enable / disable the install test" TRUE)
mark_as_advanced(ADIOS2_RUN_INSTALL_TEST)
if(BUILD_SHARED_LIBS AND ADIOS2_RUN_INSTALL_TEST)
  set(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)
  string(REGEX REPLACE "[^/]+" ".." relative_base "${CMAKE_INSTALL_LIBDIR}")

  if(APPLE)
    # Various homebrew MPI fortran installations break rpath usage on OSX
    if(APPLE AND ADIOS2_HAVE_Fortran AND ADIOS2_HAVE_MPI)
      set(CMAKE_MACOSX_RPATH OFF)
      if(NOT CMAKE_VERSION VERSION_LESS 3.17)
        set(CMAKE_INSTALL_NAME_DIR

=== bindings/CMakeLists.txt ===
#------------------------------------------------------------------------------#
# Distributed under the OSI-approved Apache License, Version 2.0.  See
# accompanying file Copyright.txt for details.
#------------------------------------------------------------------------------#

if(ADIOS2_HAVE_Python)
  add_subdirectory(Python)
endif()

if(ADIOS2_HAVE_Fortran)
  add_subdirectory(Fortran)
endif()

add_subdirectory(C)
add_subdirectory(CXX)

=== python/CMakeLists.txt ===
#------------------------------------------------------------------------------#
# Distributed under the OSI-approved Apache License, Version 2.0.  See
# accompanying file Copyright.txt for details.
#------------------------------------------------------------------------------#

add_custom_target(python_api ALL COMMAND ${CMAKE_COMMAND} -E copy_directory
                  ${CMAKE_CURRENT_SOURCE_DIR}/adios2
                  ${CMAKE_PYTHON_OUTPUT_DIRECTORY}/adios2)

set(install_location ${CMAKE_INSTALL_PYTHONDIR}/adios2)
if (ADIOS2_USE_PIP)
  set(install_location ${CMAKE_INSTALL_LIBDIR})
endif()

install(DIRECTORY ${CMAKE_PYTHON_OUTPUT_DIRECTORY}/adios2/
  DESTINATION ${install_location}
  COMPONENT adios2_python-python
  ${ADIOS2_MAYBE_EXCLUDE_FROM_ALL}
)

=== testing/CMakeLists.txt ===
# ------------------------------------------------------------------------------#
# Distributed under the OSI-approved Apache License, Version 2.0.  See
# accompanying file Copyright.txt for details.
# ------------------------------------------------------------------------------#

if(ADIOS2_HAVE_MPI)
  set(MPIEXEC_EXTRA_FLAGS "" CACHE STRING
    "Extra flags to set after mpiexec and before the num_procs flag"
  )
  mark_as_advanced(MPIEXEC_EXTRA_FLAGS)
  separate_arguments(MPIEXEC_EXTRA_FLAGS)

  set(MPIEXEC_COMMAND
    ${MPIEXEC_EXECUTABLE} ${MPIEXEC_EXTRA_FLAGS}
    ${MPIEXEC_NUMPROC_FLAG} ${MPIEXEC_MAX_NUMPROCS}
  )
endif()

include(GoogleTest)

# gtest_add_tests_helper:
# Create a wrapper around gtest_add_tests that uses common patterns for test
# names, execurtable names, mpi usage, etc.
#
# Arguments:
# testname - The basename of the test file
# mpi      - MPI_ALLOW - build MPI test, execute with mpiexec; also build Serial test
# MPI_NONE - build Serial test only
# MPI_ONLY - build MPI test only, execute with mpiexec
# src_pfx  - Source filename prefix, Test${src_pfs}${testname}.cpp
# tst_pfx  - Test name prefix to be added to CTest
# tst_sfx  - Test name suffix to be added to CTest
# all additional arguments are passed directly to gtest_add_tests
#
# Example:
# You have a gtest file, TestFooThings.cpp that containst Test1 and Test2
# gtest functions that can be called with different sets of arguments.
#
# gtest_add_tests_helper(Things MPI_ALLOW Foo Foo. .Bar EXTRA_ARGS "Bar")
# gtest_add_tests_helper(Things MPI_ALLOW Foo Foo. .Baz EXTRA_ARGS "Baz")
#
# will create the executable Test.Foo.Things and add the tests
# Foo.Things.Test1.Bar.Serial
# Foo.Things.Test1.Bar.MPI
# Foo.Things.Test2.Bar.Serial
# Foo.Things.Test2.Bar.MPI
# Foo.Things.Test1.Baz.Serial
# Foo.Things.Test1.Baz.MPI
# Foo.Things.Test2.Baz.Serial
# Foo.Things.Test2.Baz.MPI
#
function(gtest_add_tests_helper testname mpi src_pfx tst_pfx tst_sfx)
  set(test_targets "")

  if(NOT mpi MATCHES "^MPI_(ALLOW|NONE|ONLY)$")
    message(FATAL_ERROR "Invalid mpi argument value '${mpi}'.")
  endif()

  set(all_tests)

  if(NOT mpi STREQUAL "MPI_ONLY")
    set(tgt Test.${tst_pfx}${testname}.Serial)
    list(APPEND test_targets "${tgt}")

    if(NOT TARGET ${tgt})
      add_executable(${tgt} Test${src_pfx}${testname}.cpp)
      target_link_libraries(${tgt} adios2::cxx adios2::c adios2_core adios2::thirdparty::gtest)
    endif()

    gtest_add_tests(TARGET ${tgt}
      TEST_PREFIX "${tst_pfx}"
      TEST_SUFFIX "${tst_sfx}.Serial"
      TEST_LIST added_tests
      ${ARGN}
    )
    list(APPEND all_tests ${added_tests})
  endif()

  if(ADIOS2_HAVE_MPI AND NOT mpi STREQUAL "MPI_NONE")
    set(tgt Test.${tst_pfx}${testname}.MPI)
    list(APPEND test_targets "${tgt}")

    if(NOT TARGET ${tgt})
      add_executable(${tgt} Test${src_pfx}${testname}.cpp)
      target_link_libraries(${tgt} adios2::cxx_mpi adios2::c_mpi adios2_core_mpi MPI::MPI_CXX adios2::thirdparty::gtest)
    endif()

    gtest_add_tests(TARGET ${tgt}
      TEST_PREFIX "${tst_pfx}"
      TEST_SUFFIX "${tst_sfx}.MPI"
      EXEC_WRAPPER ${MPIEXEC_COMMAND}
      TEST_LIST added_tests
      ${ARGN}
    )
    list(APPEND all_tests ${added_tests})
    set_tests_properties(${added_tests} PROPERTIES PROCESSORS "${MPIEXEC_MAX_NUMPROCS}")
  endif()

  set("Test.${tst_pfx}${testname}-TESTS" "${all_tests}" PARENT_SCOPE)
  set("Test.${tst_pfx}${testname}-TARGETS" "${test_targets}" PARENT_SCOPE)
endfunction()

if(ADIOS2_HAVE_Fortran)
  function(gtest_add_tests_helper_Fortran testname mpi src_pfx tst_pfx tst_sfx wrk_dir extra_args)
    set(test_targets "")

    # message(STATUS "Add testname=${testname} src_pfx=${src_pfx} tst_pfx=${tst_pfx} tst_sfx=${tst_sfx} wrk_dir=${wrk_dir} extra=${extra_args}")
    if(NOT mpi MATCHES "^MPI_(ALLOW|NONE|ONLY)$")
      message(FATAL_ERROR "Invalid mpi argument value '${mpi}'.")
    endif()

    set(all_tests)

    if(NOT mpi STREQUAL "MPI_ONLY")
      set(tgt Test.${tst_pfx}${testname}.Serial)
      list(APPEND test_targets "${tgt}")

      if(NOT TARGET ${tgt})
        add_executable(${tgt} Test${src_pfx}${testname}.F90)
        set_target_properties(${tgt} PROPERTIES LINKER_LANGUAGE Fortran)
        target_link_libraries(${tgt} adios2::fortran adios2::thirdparty::gtest)
      endif()

      add_test(
        NAME ${tst_pfx}${src_pfx}${testname}${tst_sfx}.Serial
        COMMAND ${tgt} ${extra_args}
        WORKING_DIRECTORY ${wrk_dir}
      )
      list(APPEND all_tests ${added_tests})
    endif()

    if(ADIOS2_HAVE_MPI AND NOT mpi STREQUAL "MPI_NONE")
      set(tgt Test.${tst_pfx}${testname}.MPI)
      list(APPEND test_targets "${tgt}")

      if(NOT TARGET ${tgt})
        add_executable(${tgt} Test${src_pfx}${testname}.F90)
        set_target_properties(${tgt} PROPERTIES LINKER_LANGUAGE Fortran)
        target_link_libraries(${tgt} adios2::fortran_mpi MPI::MPI_Fortran adios2::thirdparty::gtest)
      endif()

      set(test_name ${tst_pfx}${src_pfx}${testname}${tst_sfx}.MPI)
      add_test(
        NAME ${test_name}
        COMMAND ${MPIEXEC_COMMAND} $<TARGET_FILE:${tgt}> ${extra_args}
        WORKING_DIRECTORY ${wrk_dir}
      )
      set_tests_properties(${test_name} PROPERTIES
        PROCESSORS "${MPIEXEC_MAX_NUMPROCS}"
      )
      list(APPEND all_tests ${added_tests})
      set_tests_properties(${added_tests} PROPERTIES PROCESSORS "${MPIEXEC_MAX_NUMPROCS}")
    endif()

    # message(STATUS "Creating Fortran tests ${all_tests}")
    set("Test.${tst_pfx}${testname}-TESTS" "${all_tests}" PARENT_SCOPE)
    set("Test.${tst_pfx}${testname}-TARGETS" "${test_targets}" PARENT_SCOPE)
  endfunction()
endif(ADIOS2_HAVE_Fortran)

add_subdirectory(adios2)
add_subdirectory(utils)

if(ADIOS2_RUN_INSTALL_TEST)
  add_subdirectory(install)
endif()

if(ADIOS2_BUILD_EXAMPLES)
  add_subdirectory(examples)
endif()

if(ADIOS2_HAVE_HDF5_VOL)
  add_subdirectory(h5vol)
endif()

=== thirdparty/CMakeLists.txt ===
# Disable warnings in thirdparty code
if(CMAKE_C_COMPILER_ID MATCHES
    "^(GNU|Clang|AppleClang|XLClang|XL|VisualAge|SunPro|HP|Intel|IntelLLVM|PGI|NVIDIA|NVHPC)$")
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -w")
endif()
if(CMAKE_CXX_COMPILER_ID MATCHES
    "^(GNU|Clang|AppleClang|XLClang|XL|VisualAge|SunPro|HP|Intel|IntelLLVM|PGI|NVIDIA|NVHPC)$")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -w")
endif()

function(message_start_thirdparty)
  get_filename_component(tp_base "${CMAKE_CURRENT_LIST_DIR}" NAME_WE)
  message("")
  message(STATUS "ADIOS2 ThirdParty: Configuring ${tp_base}")
endfunction()

function(message_end_thirdparty)
endfunction()

include(CMakeDependentOption)

option(ADIOS2_USE_EXTERNAL_DEPENDENCIES
  "Use externally supplied dependencies" OFF)
option(ADIOS2_USE_EXTERNAL_GTEST
  "Use an externally supplied GTest library" "${ADIOS2_USE_EXTERNAL_DEPENDENCIES}")
option(ADIOS2_USE_EXTERNAL_PUGIXML
  "Use an externally supplied pugixml library" "${ADIOS2_USE_EXTERNAL_DEPENDENCIES}")
option(ADIOS2_USE_EXTERNAL_PYBIND11
  "Use an externally supplied pybind11 library" "${ADIOS2_USE_EXTERNAL_DEPENDENCIES}")
option(ADIOS2_USE_EXTERNAL_NLOHMANN_JSON
  "Use an externally supplied nlohmann_json library" "${ADIOS2_USE_EXTERNAL_DEPENDENCIES}")
option(ADIOS2_USE_EXTERNAL_YAMLCPP
  "Use an externally supplied yaml-cpp library" "${ADIOS2_USE_EXTERNAL_DEPENDENCIES}")

add_subdirectory(KWSys)

add_subdirectory(perfstubs)
adios2_add_thirdparty_target(perfstubs-interface perfstubs-interface)

if(BUILD_TESTING)
  if(ADIOS2_USE_EXTERNAL_GTEST)
    find_package(GTest REQUIRED)
    adios2_add_thirdparty_target(gtest GTest::GTest)
  else()
    add_subdirectory(GTest)
    adios2_add_thirdparty_target(gtest gtest)
  endif()
endif()

if(ADIOS2_HAVE_Python)
  if(ADIOS2_USE_EXTERNAL_PYBIND11)
    find_package(pybind11 REQUIRED)
    adios2_add_thirdparty_target(pybind11 pybind11::pybind11)
  else()
    add_subdirectory(pybind11)
    adios2_add_thirdparty_target(pybind11 pybind11)
  endif()
endif()

if(ADIOS2_USE_EXTERNAL_PUGIXML)
  find_package(pugixml 1.10 REQUIRED)
else()
  add_subdirectory(pugixml)
endif()
adios2_add_thirdparty_target(pugixml pugixml)

# ADIOS uses a wrapper header for nlohmann_json to suppress noisy compiler
# warnings
add_subdirectory(nlohmann_json)
adios2_add_thirdparty_target(nlohmann_json nlohmann_json_wrapper)

set(yaml_cpp_target "yaml-cpp")
if(ADIOS2_USE_EXTERNAL_YAMLCPP)
  find_package(yaml-cpp 0.7.0 REQUIRED)
  if (yaml-cpp_VERSION VERSION_GREATER_EQUAL 0.8)
    set(yaml_cpp_target "yaml-cpp::yaml-cpp")
  endif()
else()
  add_subdirectory(yaml-cpp)
endif()

adios2_add_thirdparty_target(yaml-cpp ${yaml_cpp_target})

# YAML-cpp does not add the incdir/libdir to its target rather it exposes it
# through the cmake variables YAML_CPP_INCLUDE_DIR and YAML_CPP_LIBRARY_DIR
if(yaml-cpp_VERSION VERSION_GREATER_EQUAL 0.8)
  target_include_directories(adios2::thirdparty::yaml-cpp INTERFACE ${YAML_CPP_INCLUDE_DIR})
  target_link_directories(adios2::thirdparty::yaml-cpp INTERFACE ${YAML_CPP_LIBRARY_DIR})
endif()

if(WIN32)
  add_subdirectory(mingw-w64)
endif()

#------------------------------------------------------------------------------#
# SST / EVPath stuff
#------------------------------------------------------------------------------#
cmake_dependent_option(ADIOS2_USE_EXTERNAL_EVPATH
  "Use an externally supplied EVPath library" OFF
  "ADIOS2_HAVE_SST" OFF
)
cmake_dependent_option(ADIOS2_USE_EXTERNAL_ATL
  "Use an externally supplied ATL library" OFF
  "NOT ADIOS2_USE_EXTERNAL_EVPATH" ON
)
cmake_dependent_option(ADIOS2_USE_EXTERNAL_FFS
  "Use an externally supplied FFS library" OFF
  "NOT ADIOS2_USE_EXTERNAL_EVPATH" ON
)
cmake_dependent_option(ADIOS2_USE_EXTERNAL_DILL
  "Use an externally supplied DILL library" OFF
  "NOT ADIOS2_USE_EXTERNAL_FFS" ON
)
cmake_dependent_option(ADIOS2_USE_EXTERNAL_ENET
  "Use an externally supplied ENET library" OFF
  "NOT ADIOS2_USE_EXTERNAL_EVPATH" ON
)

if(NOT ADIOS2_USE_EXTERNAL_FFS)
  if(NOT ADIOS2_USE_EXTERNAL_ATL)
    add_subdirectory(atl)
  endif()
  find_package(atl REQUIRED)

  if(NOT ADIOS2_USE_EXTERNAL_DILL)
    add_subdirectory(dill)
  endif()
  find_package(dill QUIET)

  add_subdirectory(ffs)
endif()
find_package(ffs REQUIRED)
adios2_add_thirdparty_target(atl atl::atl)
adios2_add_thirdparty_target(ffs ffs::ffs)

if(NOT ADIOS2_USE_EXTERNAL_EVPATH)
  if(NOT ADIOS2_USE_EXTERNAL_ENET)
    add_subdirectory(enet)
  endif()
  find_package(enet REQUIRED)

  add_subdirectory(EVPath)
endif()
find_package(EVPath REQUIRED)
adios2_add_thirdparty_target(EVPath EVPath::EVPath)

# Keep this at the end so we see the verbose messages at least once
set(ADIOS2_THIRDPARTY_VERBOSE_DISABLE TRUE CACHE INTERNAL "" FORCE)
message("")

=== bindings/C/CMakeLists.txt ===
#------------------------------------------------------------------------------#
# Distributed under the OSI-approved Apache License, Version 2.0.  See
# accompanying file Copyright.txt for details.
#------------------------------------------------------------------------------#


add_library(adios2_c
  adios2/c/adios2_c_adios.cpp
  adios2/c/adios2_c_io.cpp
  adios2/c/adios2_c_engine.cpp
  adios2/c/adios2_c_variable.cpp
  adios2/c/adios2_c_attribute.cpp
  adios2/c/adios2_c_operator.cpp
)
set_property(TARGET adios2_c PROPERTY EXPORT_NAME c)
set_property(TARGET adios2_c PROPERTY OUTPUT_NAME adios2${ADIOS2_LIBRARY_SUFFIX}_c)
target_link_libraries(adios2_c PRIVATE adios2_core)

target_include_directories(adios2_c
  PUBLIC
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>
    $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>
  INTERFACE
    $<BUILD_INTERFACE:$<TARGET_PROPERTY:adios2_core,INTERFACE_INCLUDE_DIRECTORIES>>
)

add_library(adios2::c ALIAS adios2_c)

if(ADIOS2_HAVE_MPI)
  add_library(adios2_c_mpi
    adios2/c/adios2_c_adios_mpi.cpp
    adios2/c/adios2_c_io_mpi.cpp
    )
  set_property(TARGET adios2_c_mpi PROPERTY EXPORT_NAME c_mpi)
  set_property(TARGET adios2_c_mpi PROPERTY OUTPUT_NAME adios2${ADIOS2_LIBRARY_SUFFIX}_c_mpi)
  target_link_libraries(adios2_c_mpi PUBLIC adios2_c PRIVATE adios2_core_mpi_c PUBLIC MPI::MPI_C)
  target_compile_definitions(adios2_c_mpi INTERFACE ADIOS2_USE_MPI)
  add_library(adios2::c_mpi ALIAS adios2_c_mpi)
  set(maybe_adios2_c_mpi adios2_c_mpi)
else()
  set(maybe_adios2_c_mpi)
endif()

# Set library version information
set_target_properties(
  adios2_c ${maybe_adios2_c_mpi}
  PROPERTIES
  VERSION ${ADIOS2_LIBRARY_VERSION}
  SOVERSION ${ADIOS2_LIBRARY_SOVERSION}
)

install(TARGETS adios2_c ${maybe_adios2_c_mpi} EXPORT adios2CExports
  RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR} COMPONENT adios2_c-runtime
  LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR} COMPONENT adios2_c-libraries NAMELINK_COMPONENT adios2_c-development
  ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR} COMPONENT adios2_c-development
)

install(
  FILES adios2_c.h 
  DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}
  COMPONENT adios2_c-development
)

install(
  FILES adios2/c/adios2_c_types.h 
        adios2/c/adios2_c_adios.h
        adios2/c/adios2_c_io.h
        adios2/c/adios2_c_variable.h
        adios2/c/adios2_c_attribute.h
        adios2/c/adios2_c_engine.h
        adios2/c/adios2_c_operator.h
  DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/adios2/c
  COMPONENT adios2_c-development
)

export(EXPORT adios2CExports
  FILE ${ADIOS2_BINARY_DIR}/adios2-c-targets.cmake
  NAMESPACE adios2::
)
install(EXPORT adios2CExports
  FILE adios2-c-targets.cmake
  NAMESPACE adios2::
  DESTINATION ${CMAKE_INSTALL_CMAKEDIR}
  COMPONENT adios2_c-development
)

=== bindings/CXX/CMakeLists.txt ===
#------------------------------------------------------------------------------#
# Distributed under the OSI-approved Apache License, Version 2.0.  See
# accompanying file Copyright.txt for details.
#------------------------------------------------------------------------------#

add_library(adios2_cxx
  adios2/cxx/ADIOS.cpp
  adios2/cxx/ADIOSView.h
  adios2/cxx/Attribute.cpp
  adios2/cxx/Engine.cpp
  adios2/cxx/Engine.tcc
  adios2/cxx/IO.cpp
  adios2/cxx/IO.tcc
  adios2/cxx/Operator.cpp
  adios2/cxx/Query.cpp
  adios2/cxx/Types.cpp
  adios2/cxx/Types.tcc
  adios2/cxx/Variable.cpp
  adios2/cxx/VariableNT.cpp
  adios2/cxx/fstream/ADIOS2fstream.cpp
  adios2/cxx/Group.cpp
  adios2/cxx/Group.tcc
)

set_property(TARGET adios2_cxx PROPERTY EXPORT_NAME cxx)
set_property(TARGET adios2_cxx PROPERTY OUTPUT_NAME adios2${ADIOS2_LIBRARY_SUFFIX}_cxx)
target_link_libraries(adios2_cxx PRIVATE adios2_core)
target_compile_features(adios2_cxx INTERFACE ${ADIOS2_CXX11_FEATURES})

target_include_directories(adios2_cxx
  PUBLIC
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>
    $<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}>
    $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>
  INTERFACE
    $<BUILD_INTERFACE:$<TARGET_PROPERTY:adios2_core,INTERFACE_INCLUDE_DIRECTORIES>>
)

# Generate deprecated cxx11 wrapper headers at configure time
set(CXX11_WRAPPER_HEADERS
  ADIOS.h
  ADIOS.inl
  ADIOSView.h
  Attribute.h
  Engine.h
  Group.h
  IO.h
  KokkosView.h
  Operator.h
  Query.h
  Types.h
  Variable.h
  VariableNT.h
)

if(ADIOS2_HAVE_Derived_Variable)
  list(APPEND CXX11_WRAPPER_HEADERS VariableDerived.h)
endif()

foreach(header ${CXX11_WRAPPER_HEADERS})
  set(INCLUDE_PATH "../cxx/${header}")
  string(TOUPPER "${header}" HEADER_NAME)
  string(REPLACE "." "_" HEADER_NAME "${HEADER_NAME}")
  configure_file(
    ${CMAKE_CURRENT_SOURCE_DIR}/cxx11_wrapper.h.in
    ${CMAKE_CURRENT_BINARY_DIR}/adios2/cxx11/${header}
    @ONLY
  )
endforeach()

# Generate fstream wrapper header
set(INCLUDE_PATH "../../cxx/fstream/ADIOS2fstream.h")
set(HEADER_NAME "ADIOS2FSTREAM_H")
configure_file(
  ${CMAKE_CURRENT_SOURCE_DIR}/cxx11_wrapper.h.in
  ${CMAKE_CURRENT_BINARY_DIR}/adios2/cxx11/fstream/ADIOS2fstream.h
  @ONLY
)
unset(INCLUDE_PATH)
unset(HEADER_NAME)

add_library(adios2::cxx ALIAS adios2_cxx)

if (ADIOS2_HAVE_Derived_Variable)
    target_sources(adios2_cxx PRIVATE
      adios2/cxx/VariableDerived.cpp
  )
endif()

if(ADIOS2_HAVE_MPI)
  add_library(adios2_cxx_mpi
    adios2/cxx/ADIOSMPI.cpp
    adios2/cxx/IOMPI.cpp
    adios2/cxx/fstream/ADIOS2fstreamMPI.cpp
  )
  set_property(TARGET adios2_cxx_mpi PROPERTY EXPORT_NAME cxx_mpi)
  set_property(TARGET adios2_cxx_mpi PROPERTY OUTPUT_NAME adios2${ADIOS2_LIBRARY_SUFFIX}_cxx_mpi)
  target_link_libraries(adios2_cxx_mpi PUBLIC adios2_cxx PRIVATE adios2_core_mpi PUBLIC MPI::MPI_CXX)
  set(maybe_adios2_cxx_mpi adios2_cxx_mpi)
  target_compile_definitions(adios2_cxx_mpi INTERFACE ADIOS2_USE_MPI)
  add_library(adios2::cxx_mpi ALIAS adios2_cxx_mpi)
else()
  set(maybe_adios2_cxx_mpi)
endif()

# Set library version information
set_target_properties(
  adios2_cxx ${maybe_adios2_cxx_mpi}
  PROPERTIES
  VERSION ${ADIOS2_LIBRARY_VERSION}
  SOVERSION ${ADIOS2_LIBRARY_SOVERSION}
)

install(TARGETS adios2_cxx ${maybe_adios2_cxx_mpi} EXPORT adios2CXXExports
  RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR} COMPONENT adios2_cxx-runtime
  LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR} COMPONENT adios2_cxx-libraries NAMELINK_COMPONENT adios2_cxx-development
  ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR} COMPONENT adios2_cxx-development
)

install(
  FILES adios2.h
  DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}
  COMPONENT adios2_cxx-development
)

install(
  FILES adios2/cxx/fstream/ADIOS2fstream.h
  DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/adios2/cxx/fstream
  COMPONENT adios2_cxx-development
)

install(
  FILES ${CMAKE_CURRENT_BINARY_DIR}/adios2/cxx11/fstream/ADIOS2fstream.h
  DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/adios2/cxx11/fstream
  COMPONENT adios2_cxx11-development
)

if (ADIOS2_HAVE_Derived_Variable)
    install(
        FILES adios2/cxx/VariableDerived.h
        DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/adios2/cxx
        COMPONENT adios2_cxx-development
    )
endif()

install(
  FILES adios2/cxx/ADIOS.h
        adios2/cxx/ADIOS.inl
        adios2/cxx/ADIOSView.h
        adios2/cxx/IO.h
        adios2/cxx/Group.h
        adios2/cxx/Variable.h
        adios2/cxx/VariableNT.h
        adios2/cxx/Attribute.h
        adios2/cxx/Engine.h
        adios2/cxx/KokkosView.h
        adios2/cxx/Operator.h
        adios2/cxx/Query.h
        adios2/cxx/Types.h
  DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/adios2/cxx
  COMPONENT adios2_cxx-development
)

list(TRANSFORM CXX11_WRAPPER_HEADERS
     PREPEND "${CMAKE_CURRENT_BINARY_DIR}/adios2/cxx11/"
     OUTPUT_VARIABLE GENERATED_CXX11_HEADERS
)

install(
  FILES ${GENERATED_CXX11_HEADERS}
  DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/adios2/cxx11
  COMPONENT adios2_cxx-development
)

export(EXPORT adios2CXXExports
  FILE ${ADIOS2_BINARY_DIR}/adios2-cxx-targets.cmake
  NAMESPACE adios2::
)
install(EXPORT adios2CXXExports
  FILE adios2-cxx-targets.cmake
  NAMESPACE adios2::
  DESTINATION ${CMAKE_INSTALL_CMAKEDIR}
  COMPONENT adios2_cxx-development
)

=== bindings/Python/CMakeLists.txt ===
Python_add_library(adios2_py MODULE
  WITH_SOABI
  py11ADIOS.cpp
  py11IO.cpp
  py11Variable.cpp
  py11VariableDerived.cpp
  py11Attribute.cpp
  py11Engine.cpp
  py11Operator.cpp
  py11Query.cpp
  py11glue.cpp
)
target_compile_definitions(adios2_py PRIVATE "ADIOS2_PYTHON_MODULE_NAME=adios2_bindings${ADIOS2_LIBRARY_SUFFIX}")
if(ADIOS2_HAVE_MPI)
  target_sources(adios2_py PRIVATE
    py11ADIOSMPI.cpp
    py11IOMPI.cpp
  )
  set(maybe_adios2_cxx_mpi adios2_cxx_mpi)
  set(maybe_adios2_core_mpi adios2_core_mpi)
  set(maybe_mpi4py Python::mpi4py)
else()
  set(maybe_adios2_cxx_mpi)
  set(maybe_adios2_core_mpi)
  set(maybe_mpi4py)
endif()
target_link_libraries(adios2_py PRIVATE
  ${maybe_adios2_cxx_mpi} adios2_cxx
  ${maybe_adios2_core_mpi} adios2_core
  adios2::thirdparty::pybind11
  ${maybe_mpi4py}
  )

configure_file(
  ${CMAKE_CURRENT_SOURCE_DIR}/__init__.py.in
  ${CMAKE_PYTHON_OUTPUT_DIRECTORY}/adios2/bindings/__init__.py
  @ONLY
)

# usercustomize.py will be read by python before everything else.
# This is needed for Windows since Windows requires to point Python to the dll
# locations of ADIOS2 during our unit tests execution.
configure_file(
  ${CMAKE_CURRENT_SOURCE_DIR}/usercustomize.py.in
  ${CMAKE_PYTHON_OUTPUT_DIRECTORY}/usercustomize.py
  @ONLY
)

# We need the $<0:> for the Windows python unittests to work
set_target_properties(adios2_py PROPERTIES
  CXX_VISIBILITY_PRESET hidden
  OUTPUT_NAME adios2_bindings${ADIOS2_LIBRARY_SUFFIX}
  ARCHIVE_OUTPUT_DIRECTORY ${CMAKE_PYTHON_OUTPUT_DIRECTORY}/adios2/bindings$<0:>
  LIBRARY_OUTPUT_DIRECTORY ${CMAKE_PYTHON_OUTPUT_DIRECTORY}/adios2/bindings$<0:>
  RUNTIME_OUTPUT_DIRECTORY ${CMAKE_PYTHON_OUTPUT_DIRECTORY}/adios2/bindings$<0:>
  PDB_OUTPUT_DIRECTORY ${CMAKE_PYTHON_OUTPUT_DIRECTORY}/adios2/bindings$<0:>
  COMPILE_PDB_OUTPUT_DIRECTORY ${CMAKE_PYTHON_OUTPUT_DIRECTORY}/adios2/bindings$<0:>
)

set(install_location "${CMAKE_INSTALL_PYTHONDIR}/adios2")
if (ADIOS2_USE_PIP)
  set(install_location ${CMAKE_INSTALL_LIBDIR})
endif()

string(REGEX REPLACE "[^/]+" ".." relative_base "${install_location}/bindings")
if(CMAKE_SYSTEM_NAME MATCHES "Linux")
  set_property(TARGET adios2_py APPEND PROPERTY
    INSTALL_RPATH "$ORIGIN/${relative_base}/${CMAKE_INSTALL_LIBDIR}"
  )
endif()

install(TARGETS adios2_py
  DESTINATION ${install_location}/bindings
  COMPONENT adios2_python-python
  ${ADIOS2_MAYBE_EXCLUDE_FROM_ALL}
)
install(FILES ${CMAKE_PYTHON_OUTPUT_DIRECTORY}/adios2/bindings/__init__.py
  DESTINATION ${install_location}/bindings
  COMPONENT adios2_python-python
  ${ADIOS2_MAYBE_EXCLUDE_FROM_ALL}
)
install(DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/test
  DESTINATION ${install_location}
  COMPONENT adios2_python-python
  ${ADIOS2_MAYBE_EXCLUDE_FROM_ALL}
)

=== examples/campaign/CMakeLists.txt ===
#------------------------------------------------------------------------------#
# Distributed under the OSI-approved Apache License, Version 2.0.  See
# accompanying file Copyright.txt for details.
#------------------------------------------------------------------------------#

if(ADIOS2_HAVE_MPI)
  add_executable(adios2_campaign_write_mpi campaign_write.cpp)
  target_link_libraries(adios2_campaign_write_mpi adios2::cxx_mpi adios2_core MPI::MPI_CXX)
endif()

=== examples/useCases/CMakeLists.txt ===
# ------------------------------------------------------------------------------#
# Distributed under the OSI-approved Apache License, Version 2.0.  See
# accompanying file Copyright.txt for details.
# ------------------------------------------------------------------------------#

add_subdirectory(fidesOneCell)
add_subdirectory(insituGlobalArrays)
add_subdirectory(ensembleRead)

=== source/adios2/CMakeLists.txt ===
# ------------------------------------------------------------------------------#
# Distributed under the OSI-approved Apache License, Version 2.0.  See
# accompanying file Copyright.txt for details.
# ------------------------------------------------------------------------------#

add_library(adios2_core
  common/ADIOSTypes.cpp

  core/Attribute.cpp
  core/AttributeBase.cpp
  core/ADIOS.cpp
  core/Engine.cpp
  core/IO.cpp core/IO.tcc
  core/Operator.cpp
  core/Stream.cpp core/Stream.tcc
  core/Variable.cpp core/Variable.tcc
  core/VariableStruct.cpp
  core/VariableBase.cpp
  core/Span.cpp core/Span.tcc
  core/Group.cpp core/Group.tcc
  core/Info.cpp

  # operator
  operator/OperatorFactory.cpp
  operator/compress/CompressNull.cpp

  # helper
  helper/adiosComm.h helper/adiosComm.cpp
  helper/adiosCommDummy.h helper/adiosCommDummy.cpp
  helper/adiosDynamicBinder.h helper/adiosDynamicBinder.cpp
  helper/adiosMath.cpp
  helper/adiosMemory.cpp
  helper/adiosNetwork.cpp
  helper/adiosPartitioner.cpp
  helper/adiosPluginManager.cpp
  helper/adiosString.cpp helper/adiosString.tcc
  helper/adiosSystem.cpp
  helper/adiosType.cpp
  helper/adiosXML.cpp
  helper/adiosXMLUtil.cpp
  helper/adiosYAML.cpp
  helper/adiosLog.cpp
  helper/adiosRangeFilter.cpp

  # engine derived classes
  engine/bp3/BP3Reader.cpp engine/bp3/BP3Reader.tcc
  engine/bp3/BP3Writer.cpp engine/bp3/BP3Writer.tcc

  engine/bp4/BP4Reader.cpp engine/bp4/BP4Reader.tcc
  engine/bp4/BP4Writer.cpp engine/bp4/BP4Writer.tcc

  engine/bp5/BP5Engine.cpp
  engine/bp5/BP5Reader.cpp
  engine/bp5/BP5Reader.tcc
  engine/bp5/BP5Writer.cpp
  engine/bp5/BP5Writer_EveryoneWrites_Async.cpp
  engine/bp5/BP5Writer.tcc
  engine/bp5/BP5Writer_TwoLevelShm_Async.cpp
  engine/bp5/BP5Writer_TwoLevelShm.cpp

  engine/timeseries/TimeSeriesReader.cpp engine/timeseries/TimeSeriesReader.tcc

  engine/skeleton/SkeletonReader.cpp engine/skeleton/SkeletonReader.tcc
  engine/skeleton/SkeletonWriter.cpp engine/skeleton/SkeletonWriter.tcc

  engine/inline/InlineReader.cpp engine/inline/InlineReader.tcc
  engine/inline/InlineWriter.cpp engine/inline/InlineWriter.tcc

  engine/null/NullWriter.cpp engine/null/NullWriter.tcc
  engine/null/NullReader.cpp engine/null/NullReader.tcc

  engine/plugin/PluginEngine.cpp engine/plugin/PluginEngineInterface.cpp
  operator/plugin/PluginOperator.cpp operator/plugin/PluginOperatorInterface.cpp

  # toolkit
  toolkit/burstbuffer/FileDrainer.cpp
  toolkit/burstbuffer/FileDrainerSingleThread.cpp

  toolkit/format/buffer/Buffer.cpp
  toolkit/format/buffer/BufferV.cpp
  toolkit/format/buffer/chunk/ChunkV.cpp
  toolkit/format/buffer/ffs/BufferFFS.cpp
  toolkit/format/buffer/heap/BufferSTL.cpp
  toolkit/format/buffer/heap/BufferMalloc.cpp
  toolkit/format/buffer/malloc/MallocV.cpp

  toolkit/format/bp/BPBase.cpp toolkit/format/bp/BPBase.tcc
  toolkit/format/bp/BPSerializer.cpp toolkit/format/bp/BPSerializer.tcc

  toolkit/format/bp/bp3/BP3Base.cpp
  toolkit/format/bp/bp3/BP3Serializer.cpp toolkit/format/bp/bp3/BP3Serializer.tcc
  toolkit/format/bp/bp3/BP3Deserializer.cpp toolkit/format/bp/bp3/BP3Deserializer.tcc

  toolkit/format/bp/bp4/BP4Base.cpp
  toolkit/format/bp/bp4/BP4Serializer.cpp toolkit/format/bp/bp4/BP4Serializer.tcc
  toolkit/format/bp/bp4/BP4Deserializer.cpp toolkit/format/bp/bp4/BP4Deserializer.tcc
  toolkit/format/bp/bpBackCompatOperation/compress/BPBackCompatBlosc.cpp

  toolkit/format/bp5/BP5Base.cpp
  toolkit/format/bp5/BP5Deserializer.cpp
  toolkit/format/bp5/BP5Deserializer.tcc
  toolkit/format/bp5/BP5Serializer.cpp
  toolkit/format/bp5/BP5Helper.cpp

  toolkit/profiling/iochrono/Timer.cpp
  toolkit/profiling/iochrono/IOChrono.cpp

  toolkit/query/Query.cpp
  toolkit/query/Worker.cpp
  toolkit/query/XmlWorker.cpp
  toolkit/query/BlockIndex.cpp

  toolkit/remote/Remote.cpp

  toolkit/transport/Transport.cpp
  toolkit/transport/file/FileStdio.cpp
  toolkit/transport/file/FileFStream.cpp
  toolkit/transport/null/NullTransport.cpp

  toolkit/transportman/TransportMan.cpp

  toolkit/shm/Spinlock.cpp
  toolkit/shm/SerializeProcesses.cpp
  toolkit/shm/TokenChain.h

  toolkit/aggregator/mpi/MPIAggregator.cpp
  toolkit/aggregator/mpi/MPIChain.cpp
  toolkit/aggregator/mpi/MPIShmChain.cpp
)
set_property(TARGET adios2_core PROPERTY EXPORT_NAME core)
set_property(TARGET adios2_core PROPERTY OUTPUT_NAME adios2${ADIOS2_LIBRARY_SUFFIX}_core)

set(maybe_adios2_core_derived)

if(ADIOS2_HAVE_Derived_Variable)
  target_sources(adios2_core PRIVATE
    core/VariableDerived.cpp
    toolkit/derived/Expression.cpp
    toolkit/derived/Function.cpp)
  set_target_properties(adios2_core PROPERTIES
    INCLUDE_DIRECTORIES "$<BUILD_INTERFACE:${ADIOS2_SOURCE_DIR}/source/adios2/toolkit/derived/parser>;$<BUILD_INTERFACE:${ADIOS2_BINARY_DIR}/source/adios2>")
  find_package(BISON "3.8.2")
  find_package(FLEX)

  if(NOT BISON_FOUND OR NOT FLEX_FOUND OR(NOT BISON_VERSION VERSION_GREATER_EQUAL "3.8.2"))
    include(ADIOSBisonFlexSub)
    SETUP_ADIOS_BISON_FLEX_SUB()
  else()
    BISON_TARGET(MyParser
      toolkit/derived/parser/parser.y
      ${CMAKE_CURRENT_BINARY_DIR}/parser.cpp
      COMPILE_FLAGS "-o parser.cpp --header=parser.h"
      DEFINES_FILE ${CMAKE_CURRENT_BINARY_DIR}/parser.h)
    FLEX_TARGET(MyScanner
      toolkit/derived/parser/lexer.l
      ${CMAKE_CURRENT_BINARY_DIR}/lexer.cpp
      COMPILE_FLAGS "-o lexer.cpp --header-file=lexer.h"
      DEFINES_FILE ${CMAKE_CURRENT_BINARY_DIR}/lexer.h)
    ADD_FLEX_BISON_DEPENDENCY(MyScanner MyParser)
  endif()

  if("${CMAKE_CXX_COMPILER_ID}" STREQUAL "GNU")
    SET_SOURCE_FILES_PROPERTIES(${CMAKE_CURRENT_BINARY_DIR}/lexer.cpp PROPERTIES COMPILE_FLAGS -Wno-sign-compare)
  elseif("${CMAKE_CXX_COMPILER_ID}" STREQUAL "Intel")
    SET_SOURCE_FILES_PROPERTIES(${CMAKE_CURRENT_BINARY_DIR}/parser.cpp PROPERTIES COMPILE_FLAGS -Wno-unused-but-set-variable)
  elseif("${CMAKE_CXX_COMPILER_ID}" STREQUAL "AppleClang")
    SET_SOURCE_FILES_PROPERTIES(${CMAKE_CURRENT_BINARY_DIR}/parser.cpp PROPERTIES COMPILE_FLAGS -Wno-unused-but-set-variable)
  elseif("${CMAKE_CXX_COMPILER_ID}" STREQUAL "IntelLLVM")
    SET_SOURCE_FILES_PROPERTIES(${CMAKE_CURRENT_BINARY_DIR}/parser.cpp PROPERTIES COMPILE_FLAGS -Wno-unused-but-set-variable)
  elseif("${CMAKE_CXX_COMPILER_ID}" STREQUAL "MSVC")
    SET_SOURCE_FILES_PROPERTIES(toolkit/derived/Expression.cpp toolkit/derived/Function.cpp PROPERTIES COMPILE_FLAGS "/wd4005 /wd4065 /wd4267 -DYY_NO_UNISTD_H")
  endif()

  add_library(adios2_core_derived
    ${CMAKE_CURRENT_BINARY_DIR}/lexer.cpp
    ${CMAKE_CURRENT_BINARY_DIR}/parser.cpp
    toolkit/derived/parser/ASTDriver.cpp
    toolkit/derived/parser/ASTNode.cpp)
  set_target_properties(adios2_core_derived PROPERTIES
    VISIBILITY_INLINES_HIDDEN ON
    INCLUDE_DIRECTORIES "$<BUILD_INTERFACE:${ADIOS2_SOURCE_DIR}/source/adios2/toolkit/derived/parser>;$<BUILD_INTERFACE:${ADIOS2_BINARY_DIR}/source/adios2>"
    EXPORT_NAME core_derived
    OUTPUT_NAME adios2${ADIOS2_LIBRARY_SUFFIX}_core_derived)
  target_link_libraries(adios2_core PRIVATE adios2_core_derived)
  set(maybe_adios2_core_derived adios2_core_derived)

  if(CMAKE_CXX_COMPILER_ID STREQUAL "MSVC")
    set_target_properties(adios2_core_derived PROPERTIES COMPILE_FLAGS "/wd4005 /wd4267 /wd4065 -DYY_NO_UNISTD_H")
  endif()
endif()

set(maybe_adios2_core_cuda)

if(ADIOS2_HAVE_CUDA)
  add_library(adios2_core_cuda helper/adiosCUDA.cu)
  set_target_properties(adios2_core_cuda PROPERTIES
    CUDA_SEPARABLE_COMPILATION ON
    CUDA_VISIBILITY_PRESET hidden
    VISIBILITY_INLINES_HIDDEN ON
    INCLUDE_DIRECTORIES "$<BUILD_INTERFACE:${ADIOS2_SOURCE_DIR}/source>;$<BUILD_INTERFACE:${ADIOS2_BINARY_DIR}/source>"
    EXPORT_NAME core_cuda
    OUTPUT_NAME adios2${ADIOS2_LIBRARY_SUFFIX}_core_cuda
  )
  target_link_libraries(adios2_core PRIVATE adios2_core_cuda CUDA::cudart)
  set(maybe_adios2_core_cuda adios2_core_cuda)
endif()

set(maybe_adios2_core_kokkos)

if(ADIOS2_HAVE_Kokkos)
  # Kokkos imposes us to set our CMAKE_CXX_COMPILER to Kokkos_CXX_COMPILER.
  # The problem is that we do not want this for the whole project and with
  # CMake we cannot set the CXX_COMPILER for a single target. The solution is
  # to move the adios2 module that uses Kokkos to its independent subdir and
  # set there CMAKE_CXX_COMPILER, which is possible (and scoped to that subdir)
  # in cmake.
  add_subdirectory(helper/kokkos)
  target_link_libraries(adios2_core PRIVATE adios2_core_kokkos)
  set(maybe_adios2_core_kokkos adios2_core_kokkos)
endif()

target_include_directories(adios2_core
  PUBLIC
  $<BUILD_INTERFACE:${ADIOS2_SOURCE_DIR}/source>
  $<BUILD_INTERFACE:${ADIOS2_BINARY_DIR}/source>
)
target_link_libraries(adios2_core PRIVATE
  adios2sys_interface
  adios2::thirdparty::pugixml
  adios2::thirdparty::yaml-cpp
  adios2::thirdparty::nlohmann_json
  adios2::thirdparty::perfstubs-interface
  adios2::thirdparty::ffs
)
target_link_libraries(adios2_core PUBLIC ${CMAKE_THREAD_LIBS_INIT})
target_compile_features(adios2_core PUBLIC "$<BUILD_INTERFACE:${ADIOS2_CXX11_FEATURES}>")

target_sources(adios2_core PRIVATE toolkit/transport/file/FilePOSIX.cpp)
target_sources(adios2_core PRIVATE toolkit/transport/file/FileHTTP.cpp)

if(ADIOS2_HAVE_AWSSDK)
  target_sources(adios2_core PRIVATE toolkit/transport/file/FileAWSSDK.cpp)
  target_link_libraries(adios2_core PRIVATE ${AWSSDK_LINK_LIBRARIES})
endif()

if(ADIOS2_HAVE_OpenSSL)
  target_sources(adios2_core PRIVATE toolkit/transport/file/FileHTTPS.cpp)
  target_link_libraries(adios2_core PRIVATE OpenSSL::Crypto OpenSSL::SSL)
endif()

if(ADIOS2_HAVE_XRootD)
  target_sources(adios2_core PRIVATE toolkit/remote/XrootdRemote.cpp)
  target_include_directories(adios2_core PRIVATE ${XROOTD_INCLUDE_DIRS})
  target_link_libraries(adios2_core PRIVATE ${XROOTD_CLIENT_LIBRARIES} ${XROOTD_UTILS_LIBRARIES} ${XROOTD_SSI_LIBRARIES})
endif()

if(ADIOS2_HAVE_SST)
  # EVPath-enabled remote file transport
  target_sources(adios2_core PRIVATE toolkit/remote/remote_common.cpp toolkit/transport/file/FileRemote.cpp toolkit/remote/EVPathRemote.cpp)
  target_link_libraries(adios2_core PRIVATE adios2::thirdparty::EVPath)
  add_subdirectory(toolkit/remote)
endif()

if(ADIOS2_HAVE_KVCACHE)
  target_sources(adios2_core PRIVATE toolkit/kvcache/KVCacheCommon.cpp)
  target_link_libraries(adios2_core PRIVATE hiredis::hiredis)
endif()

if(ADIOS2_HAVE_Campaign)
  target_sources(adios2_core PRIVATE
    engine/campaign/CampaignReader.cpp
    engine/campaign/CampaignReader.tcc
    engine/campaign/CampaignData.cpp
    engine/campaign/CampaignManager.cpp)
  target_link_libraries(adios2_core PRIVATE SQLite::SQLite3 ZLIB::ZLIB)

  if(ADIOS2_HAVE_Sodium)
    target_link_libraries(adios2_core PRIVATE sodium)
  endif(ADIOS2_HAVE_Sodium)
endif(ADIOS2_HAVE_Campaign)

if(ADIOS2_HAVE_DAOS)
  target_sources(adios2_core PRIVATE toolkit/transport/file/FileDaos.cpp
    engine/daos/DaosEngine.cpp
    engine/daos/DaosWriter_EveryoneWrites_Async.cpp
    engine/daos/DaosWriter_TwoLevelShm_Async.cpp
    engine/daos/DaosWriter_TwoLevelShm.cpp
    engine/daos/DaosReader.cpp engine/daos/DaosReader.tcc
    engine/daos/DaosWriter.cpp engine/daos/DaosWriter.tcc)
  set(maybe_CaliperLib)
  if (ADIOS2_HAVE_Caliper)
     set (maybe_CaliperLib Caliper::Caliper)
  endif()
  target_link_libraries(adios2_core PRIVATE DAOS::DAOS ${maybe_CaliperLib})
endif()

if(ADIOS2_HAVE_MPI)
  add_library(adios2_core_mpi
    core/IOMPI.cpp
    helper/adiosCommMPI.h helper/adiosCommMPI.cpp
    helper/adiosMpiHandshake.h helper/adiosMpiHandshake.cpp
    engine/ssc/SscHelper.cpp
    engine/ssc/SscWriter.cpp
    engine/ssc/SscWriterBase.cpp
    engine/ssc/SscWriterGeneric.cpp
    engine/ssc/SscWriterNaive.cpp
    engine/ssc/SscReader.cpp
    engine/ssc/SscReaderBase.cpp
    engine/ssc/SscReaderGeneric.cpp
    engine/ssc/SscReaderNaive.cpp
  )
  set_property(TARGET adios2_core_mpi PROPERTY EXPORT_NAME core_mpi)
  set_property(TARGET adios2_core_mpi PROPERTY OUTPUT_NAME adios2${ADIOS2_LIBRARY_SUFFIX}_core_mpi)

=== source/utils/CMakeLists.txt ===
#------------------------------------------------------------------------------#
# Distributed under the OSI-approved Apache License, Version 2.0.  See
# accompanying file Copyright.txt for details.
#------------------------------------------------------------------------------#

configure_file(
  "${CMAKE_CURRENT_SOURCE_DIR}/verinfo.h.in"
  "${PROJECT_BINARY_DIR}/verinfo.h"
  @ONLY
)

# BPLS
add_executable(bpls ./bpls/bpls.cpp)
target_link_libraries(bpls
                      PUBLIC adios2_core adios2sys
                      PRIVATE adios2::thirdparty::pugixml $<$<PLATFORM_ID:Windows>:shlwapi>)

target_include_directories(bpls PRIVATE
  ${PROJECT_BINARY_DIR}
  ${PROJECT_SOURCE_DIR}/bindings/C
)

set_property(TARGET bpls PROPERTY OUTPUT_NAME bpls${ADIOS2_EXECUTABLE_SUFFIX})
install(TARGETS bpls EXPORT adios2
  RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR} COMPONENT adios2_tools-runtime
  ${ADIOS2_MAYBE_EXCLUDE_FROM_ALL}
)
configure_file(
  "${CMAKE_CURRENT_SOURCE_DIR}/bpls/bpls.cmake.gen.in"
  "${CMAKE_CURRENT_BINARY_DIR}/bpls.cmake.gen"
  @ONLY
)
file(GENERATE
  OUTPUT "${PROJECT_BINARY_DIR}/$<CONFIG>/bpls.cmake"
  INPUT "${CMAKE_CURRENT_BINARY_DIR}/bpls.cmake.gen"
)

# BPCMP
if(ADIOS2_HAVE_Python)
  add_subdirectory(bpcmp)

  configure_file(
    "${CMAKE_CURRENT_SOURCE_DIR}/bpcmp/bpcmp.cmake.gen.in"
    "${CMAKE_CURRENT_BINARY_DIR}/bpcmp.cmake.gen"
    @ONLY
  )
  file(GENERATE
    OUTPUT "${PROJECT_BINARY_DIR}/$<CONFIG>/bpcmp.cmake"
    INPUT "${CMAKE_CURRENT_BINARY_DIR}/bpcmp.cmake.gen"
  )
endif()

# BPSPLIT
#add_executable(bpsplit ./bpsplit/bpsplit.cpp)
#target_link_libraries(bpsplit adios2::cxx adios2sys_interface adios2::thirdparty::pugixml)
#install(TARGETS bpsplit EXPORT adios2
#  RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
#)

# ADIOS_REORGANIZE
set(adios_reorganize_srcs
  adios_reorganize/main.cpp
  adios_reorganize/Reorganize.cpp
  Utils.cpp
  )
if(ADIOS2_HAVE_MGARD)
  set(maybe_mgard mgard::mgard)
else()
  set(maybe_mgard)
endif()
add_executable(adios_reorganize ${adios_reorganize_srcs})
target_link_libraries(adios_reorganize PRIVATE adios2_core ${maybe_mgard})
set_property(TARGET adios_reorganize PROPERTY OUTPUT_NAME adios2_reorganize${ADIOS2_EXECUTABLE_SUFFIX})

if(ADIOS2_HAVE_MPI)
  add_executable(adios_reorganize_mpi ${adios_reorganize_srcs})
  target_link_libraries(adios_reorganize_mpi PRIVATE adios2_core_mpi ${maybe_mgard})
  set_property(TARGET adios_reorganize_mpi PROPERTY OUTPUT_NAME adios2_reorganize_mpi${ADIOS2_EXECUTABLE_SUFFIX})
  set(maybe_adios_reorganize_mpi adios_reorganize_mpi)
else()
  set(maybe_adios_reorganize_mpi)
endif()

install(TARGETS adios_reorganize
  ${maybe_adios_reorganize_mpi}
  EXPORT adios2
  RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR} COMPONENT adios2_tools-runtime
  ${ADIOS2_MAYBE_EXCLUDE_FROM_ALL}
)

if(ADIOS2_HAVE_MPI)
  add_subdirectory(adios_iotest)
endif()

if(Python_Interpreter_FOUND)
  add_subdirectory(bp4dbg)
  add_subdirectory(bp5dbg)
  install(PROGRAMS adios2_json_pp.py
    RENAME adios2_json_pp
    DESTINATION ${CMAKE_INSTALL_BINDIR}
    COMPONENT adios2_scripts-runtime
    ${ADIOS2_MAYBE_EXCLUDE_FROM_ALL}
  )
endif()

install(PROGRAMS adios2_deactivate_bp
  RENAME adios2_deactivate_bp
  DESTINATION ${CMAKE_INSTALL_BINDIR}
  COMPONENT adios2_scripts-runtime
  ${ADIOS2_MAYBE_EXCLUDE_FROM_ALL}
)

# Simplified wrappers for adios2_reorganize
configure_file(
  "${CMAKE_CURRENT_SOURCE_DIR}/adios_reorganize/adios2_reorganize_wrapper"
  "${PROJECT_BINARY_DIR}/adios2_reorganize_wrapper"
  @ONLY
)

if(ADIOS2_HAVE_HDF5)
  install(PROGRAMS ${PROJECT_BINARY_DIR}/adios2_reorganize_wrapper
    RENAME bp2h5${ADIOS2_EXECUTABLE_SUFFIX}
    DESTINATION ${CMAKE_INSTALL_BINDIR}
  )
  if(ADIOS2_HAVE_MPI)
    install(PROGRAMS ${PROJECT_BINARY_DIR}/adios2_reorganize_wrapper
      RENAME bp2h5_mpi${ADIOS2_EXECUTABLE_SUFFIX}
      DESTINATION ${CMAKE_INSTALL_BINDIR}
    )
  endif()
endif()
if (ADIOS2_HAVE_XRootD)
  add_subdirectory(xrootd-plugin)
endif ()

=== debian/changelog ===
adios2 (2.11.0+dfsg1-6) unstable; urgency=medium

  * Build-Depends: bison, flex
    Needed by hurd-amd64 in particular.

 -- Drew Parsons <dparsons@debian.org>  Fri, 13 Feb 2026 11:48:06 +0100

adios2 (2.11.0+dfsg1-5) unstable; urgency=medium

  * tighten Build-Depends: libfabric-dev to [linux-any]
    as done for libfabric-dev itself (i.e. not available on hurd)

 -- Drew Parsons <dparsons@debian.org>  Fri, 06 Feb 2026 19:14:32 +0100

adios2 (2.11.0+dfsg1-4) unstable; urgency=medium

  * Build-Depends: libblosc2-dev on little-endian architectures only
    (cf. c-blosc2 upstream issue #702). Use white list
    [amd64 arm64 loong64 ppc64el riscv64 alpha] (remember adios2 only
    supports 64-bit arches). Closes: #1126565

 -- Drew Parsons <dparsons@debian.org>  Wed, 28 Jan 2026 20:43:32 +0100

adios2 (2.11.0+dfsg1-3) unstable; urgency=medium

  * debian patch standalone_examples.patch adds project and
    cmake_minimum_required (3.14, to match top level) to
    examples/CMakeLists.txt to enable examples to build independently
    of the library build without warnings or errors. Closes: #1125522

 -- Drew Parsons <dparsons@debian.org>  Fri, 16 Jan 2026 16:05:53 +0000

adios2 (2.11.0+dfsg1-2) unstable; urgency=medium

  * Standards-Version: 4.7.3

 -- Drew Parsons <dparsons@debian.org>  Mon, 12 Jan 2026 19:44:38 +1100

adios2 (2.11.0+dfsg1-1exp4) experimental; urgency=medium

  * debian/test/adios2-mpi-examples: skip python tests in python test
    section (bpReaderHeatMap2D.py fails on bigendian systems i.e. s390x)

 -- Drew Parsons <dparsons@debian.org>  Mon, 12 Jan 2026 18:34:26 +1100

adios2 (2.11.0+dfsg1-1exp3) experimental; urgency=medium

  * debian/tests: MPI example skips must be applied in
    adios2-mpi-examples not adios2-serial-examples

 -- Drew Parsons <dparsons@debian.org>  Mon, 12 Jan 2026 11:18:40 +1100

adios2 (2.11.0+dfsg1-1exp2) experimental; urgency=medium

  * debian/tests: skip more examples failing on bigendian (s390x).
    See Bug#1125266 (upstream Issue#4794)

 -- Drew Parsons <dparsons@debian.org>  Mon, 12 Jan 2026 04:25:27 +1100

adios2 (2.11.0+dfsg1-1exp1) experimental; urgency=medium

  * New upstream release
    - new ABI 2.11
    - applies debian patches 0016-Fix-a-typo.patch
      0019-Use-proper-dynamic-vector-construction-to-fix-segfau.patch
      fix_adios2-config_DESTDIR_revoke_PR3850.patch
      fix_example_hello_bpFWriteCRead_PR4239.patch
    - C++ build target is now just adios2_cxx not adios2_cxx11
  * follow upstream in dropping 11 from c++ package names
    (just use c++ not c++11 now)
    libadios2-*-c++-dev Breaks: Replaces: Provides: libadios2-*-c++11-dev
  * mark libadios2-{mpi,serial,common}-core-dev Multi-Arch: same
  * update debian/rules
    - install files to libadios2-*-c++11-dev packages from the
      adios2_cxx11-development component as well the
      adios2_cxx-development component. Header files are now moved to
      the cxx subdir but compatibility wrapper headers are still
      provided in the cxx11 subdir
    - install common python files into python3-adios2 rather than
      python3-adios2-serial or python3-adios2-mpi
  * update debian/tests
    - run examples using upstream's CMakeLists.txt
    - drop debian patch fix_examples_cmake.patch
    - skip plugin engine examples (Read and Write). They do not run
      successfully as-is (plugin names are mangled)
    - debian patch test_examples_serial.patch uses TEST_SERIAL to run
      serial tests when MPI is installed
  * update debian/watch to v5 format.
    Use Uversion-Mangle: auto to place rc releases below final release.

 -- Drew Parsons <dparsons@debian.org>  Sun, 07 Dec 2025 18:32:13 +0100

=== debian/control ===
Source: adios2
Priority: optional
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Drew Parsons <dparsons@debian.org>,
           Francesco Ballarin <francesco.ballarin@unicatt.it>
Build-Depends:
    architecture-is-64-bit, architecture-properties,
    debhelper-compat (= 13),
    dh-cmake,
    dh-cmake-compat (= 1),
    dh-sequence-cmake,
    dh-sequence-ctest,
    dh-sequence-python3,
    cmake,
    ninja-build,
    bison,
    flex,
    gfortran,
    pkgconf,
    libenet-dev,
    libpugixml-dev,
    libsodium-dev,
    libyaml-cpp-dev,
    pybind11-dev,
    libgtest-dev,
    nlohmann-json3-dev,
    python3-all-dev,
    python3-numpy,
    libblosc2-dev [amd64 arm64 loong64 ppc64el riscv64 alpha],
    liblz4-dev,
    libbz2-dev,
    libpng-dev,
    libczmq-dev,
    libhdf5-serial-dev,
    libhdf5-mpi-dev,
    libfabric-dev [linux-any],
    libffi-dev,
    libucx-dev [amd64 arm64],
    libzfp-dev,
    mpi-default-dev,
    python3-mpi4py
Standards-Version: 4.7.3
Section: libs
Homepage: https://github.com/ornladios/ADIOS2
Vcs-Browser: https://salsa.debian.org/science-team/adios2
Vcs-Git: https://salsa.debian.org/science-team/adios2.git

Package: adios2-data
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Description: ADIOS2 Adaptable IO system for simulations - tool data
 The Adaptable IO System (ADIOS) provides a simple, flexible way for
 scientists to describe the data in their code that may need to be
 written, read, or processed outside of the running simulation. By
 providing an external to the code XML file describing the various
 elements, their types, and how you wish to process them this run, the
 routines in the host code (either Fortran or C) can transparently
 change how they process the data.
 .
 This package contains tool data for ADIOS2.

Package: adios2-scripts
Architecture: all
Multi-Arch: foreign
Depends: ${python3:Depends}, ${misc:Depends}
Description: ADIOS2 Adaptable IO system for simulations - scripts
 The Adaptable IO System (ADIOS) provides a simple, flexible way for
 scientists to describe the data in their code that may need to be
 written, read, or processed outside of the running simulation. By
 providing an external to the code XML file describing the various
 elements, their types, and how you wish to process them this run, the
 routines in the host code (either Fortran or C) can transparently
 change how they process the data.
 .
 This package contains scripts for ADIOS2.

Package: adios2-serial-bin
Architecture: any
Depends: adios2-scripts, ${shlibs:Depends}, ${misc:Depends}
Description: ADIOS2 Adaptable IO system for simulations - binary tools (serial)
 The Adaptable IO System (ADIOS) provides a simple, flexible way for
 scientists to describe the data in their code that may need to be
 written, read, or processed outside of the running simulation. By
 providing an external to the code XML file describing the various
 elements, their types, and how you wish to process them this run, the
 routines in the host code (either Fortran or C) can transparently
 change how they process the data.
 .
 This package contains binary tools for ADIOS2.

Package: libadios2-serial-core-2.11
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends},
 libadios2-serial-plugins (= ${binary:Version})
Description: ADIOS2 Adaptable IO system for simulations - core libraries (serial)
 The Adaptable IO System (ADIOS) provides a simple, flexible way for
 scientists to describe the data in their code that may need to be
 written, read, or processed outside of the running simulation. By
 providing an external to the code XML file describing the various
 elements, their types, and how you wish to process them this run, the
 routines in the host code (either Fortran or C) can transparently
 change how they process the data.
 .
 This package contains the core libraries for the serial build of
 ADIOS2.

Package: libadios2-serial-plugins
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Replaces: libadios2-serial-core-2
Breaks: libadios2-serial-core-2
Description: ADIOS2 Adaptable IO system for simulations - core libraries (serial)
 The Adaptable IO System (ADIOS) provides a simple, flexible way for
 scientists to describe the data in their code that may need to be
 written, read, or processed outside of the running simulation. By
 providing an external to the code XML file describing the various
 elements, their types, and how you wish to process them this run, the
 routines in the host code (either Fortran or C) can transparently
 change how they process the data.
 .
 This package contains the plugin libraries for the serial build of
 ADIOS2.

Package: libadios2-serial-core-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libadios2-serial-core-2.11 (= ${binary:Version}),
 libadios2-common-core-dev (= ${binary:Version}),
 libadios2-serial-auxiliary-dev (= ${binary:Version}),
 ${misc:Depends}
Description: Adaptable IO system for simulations - core development files (serial)
 The Adaptable IO System (ADIOS) provides a simple, flexible way for
 scientists to describe the data in their code that may need to be
 written, read, or processed outside of the running simulation. By
 providing an external to the code XML file describing the various
 elements, their types, and how you wish to process them this run, the
 routines in the host code (either Fortran or C) can transparently
 change how they process the data.
 .
 This package contains the core development files for the serial build
 of ADIOS2.

Package: libadios2-serial-c-2.11
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: ADIOS2 Adaptable IO system for simulations - C binding libraries (serial)
 The Adaptable IO System (ADIOS) provides a simple, flexible way for
 scientists to describe the data in their code that may need to be
 written, read, or processed outside of the running simulation. By
 providing an external to the code XML file describing the various
 elements, their types, and how you wish to process them this run, the
 routines in the host code (either Fortran or C) can transparently
 change how they process the data.
 .
 This package contains the C binding libraries for the serial build of
 ADIOS2.

Package: libadios2-serial-c-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
    libadios2-serial-c-2.11 (= ${binary:Version}),
    libadios2-common-c-dev (= ${source:Version}),
    libadios2-serial-core-dev (= ${binary:Version}),
    ${misc:Depends}
Description: Adaptable IO system for simulations - C binding development files (serial)
 The Adaptable IO System (ADIOS) provides a simple, flexible way for
 scientists to describe the data in their code that may need to be
 written, read, or processed outside of the running simulation. By
 providing an external to the code XML file describing the various
 elements, their types, and how you wish to process them this run, the
 routines in the host code (either Fortran or C) can transparently
 change how they process the data.
 .
 This package contains the C binding development files for the serial
 build of ADIOS2.

Package: libadios2-serial-c++-2.11
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: ADIOS2 Adaptable IO system for simulations - C++ binding libraries (serial)
 The Adaptable IO System (ADIOS) provides a simple, flexible way for
 scientists to describe the data in their code that may need to be
 written, read, or processed outside of the running simulation. By
 providing an external to the code XML file describing the various
 elements, their types, and how you wish to process them this run, the
 routines in the host code (either Fortran or C) can transparently
 change how they process the data.
 .
 This package contains the C++ binding libraries for the serial build of
 ADIOS2.

Package: libadios2-serial-c++-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
    libadios2-serial-c++-2.11 (= ${binary:Version}),
    libadios2-common-c++-dev (= ${source:Version}),
    libadios2-serial-core-dev (= ${binary:Version}),
    ${misc:Depends}
Breaks: libadios2-serial-c++11-dev
Replaces: libadios2-serial-c++11-dev
Provides: libadios2-serial-c++11-dev
Description: Adaptable IO system for simulations - C++ binding development files (serial)
 The Adaptable IO System (ADIOS) provides a simple, flexible way for
 scientists to describe the data in their code that may need to be
 written, read, or processed outside of the running simulation. By
 providing an external to the code XML file describing the various
 elements, their types, and how you wish to process them this run, the
 routines in the host code (either Fortran or C) can transparently
 change how they process the data.
 .
 This package contains the C++ binding development files for the serial
 build of ADIOS2.

Package: libadios2-serial-fortran-2.11
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: ADIOS2 Adaptable IO system for simulations - Fortran binding libraries (serial)
 The Adaptable IO System (ADIOS) provides a simple, flexible way for
 scientists to describe the data in their code that may need to be
 written, read, or processed outside of the running simulation. By
 providing an external to the code XML file describing the various
 elements, their types, and how you wish to process them this run, the
 routines in the host code (either Fortran or C) can transparently
 change how they process the data.
 .
 This package contains the Fortran binding libraries for the serial build of
 ADIOS2.

Package: libadios2-serial-fortran-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
    libadios2-serial-fortran-2.11 (= ${binary:Version}),
    libadios2-serial-core-dev (= ${binary:Version}),
    ${misc:Depends}
Conflicts: libadios2-mpi-fortran-dev
Description: Adaptable IO system for simulations - Fortran binding development files (serial)
 The Adaptable IO System (ADIOS) provides a simple, flexible way for
 scientists to describe the data in their code that may need to be
 written, read, or processed outside of the running simulation. By
 providing an external to the code XML file describing the various
 elements, their types, and how you wish to process them this run, the
 routines in the host code (either Fortran or C) can transparently
 change how they process the data.
 .
 This package contains the Fortran binding development files for the serial
 build of ADIOS2.

Package: libadios2-serial-auxiliary-2.11
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: ADIOS2 Adaptable IO system for simulations - auxiliary libraries (serial)
 The Adaptable IO System (ADIOS) provides a simple, flexible way for
 scientists to describe the data in their code that may need to be
 written, read, or processed outside of the running simulation. By
 providing an external to the code XML file describing the various
 elements, their types, and how you wish to process them this run, the
 routines in the host code (either Fortran or C) can transparently
 change how they process the data.
 .
 This package contains the auxiliary thirdparty libraries required
 by the serial build of ADIOS2, which are not yet packaged separately:
  - atl
  - dill
  - EVPath
  - ffs
  - perfstubs

Package: libadios2-serial-auxiliary-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
    libadios2-serial-auxiliary-2.11 (= ${binary:Version}),
    ${misc:Depends}
Description: Adaptable IO system for simulations - auxiliary development files (serial)
 The Adaptable IO System (ADIOS) provides a simple, flexible way for
 scientists to describe the data in their code that may need to be
 written, read, or processed outside of the running simulation. By

=== debian/tests/control ===
Tests: adios2-serial-test, adios2-serial-examples
Depends: libadios2-serial-c-dev,
 libadios2-serial-c++-dev,
 libadios2-serial-fortran-dev,
 libadios2-serial-plugins,
 python3-adios2,
 python3-all,
 @builddeps@
Restrictions: allow-stderr

Tests: adios2-mpi-test, adios2-mpi-examples
Depends: libadios2-mpi-c-dev,
 libadios2-mpi-c++-dev,
 libadios2-mpi-fortran-dev,
 libadios2-mpi-plugins,
 python3-adios2, python3-adios2-mpi,
 python3-all,
 @builddeps@
Restrictions: allow-stderr
